-- Grammatik der Klammergebirge (eindeutig, weil einfach)

with Text_IO; use Text_IO;
with GrammatikGenerator;

procedure BinaerMod3Rest2 is

   type Grammatiksymbole is (S,R0,R1,R2,'0','1');

   package BM_Grammatik is new GrammatikGenerator(Grammatiksymbole,4);
   use BM_Grammatik;
    
   rechteSeiten : Zeichenarray(1..12) := 
     ('0',R0,'1',R1,'0',R2,'1',R0,'0',R1,'1',R2);
   
   test1 : Wort (1..4) := ('1','1','1','1');
   test2 : Wort (1..4) := ('0','1','1','0');
   test3 : Wort (1..4) := ('1','1','1','0');


                       
begin
     
   neueAlternativeHinzu(S, rechteSeiten(3..4));  
   
   neueAlternativeHinzu(R0, rechteSeiten(1..2)); 
   neueAlternativeHinzu(R0, rechteSeiten(3..4)); 
   
   neueAlternativeHinzu(R1, rechteSeiten(5..6)); 
   neueAlternativeHinzu(R1, rechteSeiten(7..8)); 

   
   neueAlternativeHinzu(R2, rechteSeiten(9..10)); 
   neueAlternativeHinzu(R2, rechteSeiten(11..12)); 
   neueAlternativeHinzu(R2, rechteSeiten(1..0)); 


     
   druckeGrammatik; 
     
   new_line(2);
   
   if hatEpsilonRegel(S) then
      put ("S ist epsilon-Symbol");
   end if;

   new_line(2); 
   put_line("1111 liegt wegen");
   
   if not wortImSprachschatz(test1) then
      put ("nicht ");
   end if;
   
   put("im Sprachschatz ");
     

   new_line(2); 
   put_line("0110 liegt wegen");
   
   if not wortImSprachschatz(test2) then
      put ("nicht ");
   end if;
   
   put("im Sprachschatz ");
     

   new_line(2); 
   put_line("1110 liegt wegen");
   
   if not wortImSprachschatz(test3) then
      put ("nicht ");
   end if;
   
   put("im Sprachschatz ");
     

     
end BinaerMod3Rest2;
