-- generisches Package zur Erzeugung einer Adjazenzmatrix 
-- aus einer Liste
-- Package Specification

with Matrix;
generic

-- Festlegung des generischen Typs Z
   type Z is (<>); 


   package ToAdi is

   package Mat is new Matrix(Z);
   use Mat;
   
-- Festlegung einer Liste mittels Pointer.
--  Liste enthlt zwei Elemente, die eine Verknpfung darstellen.
--  Bsp: A-->S -- Pos1:= A ; Pos2:= S;
--  Rest ist ein Pointer auf das folgende Element.
   type Tupel;
   type TupelPoint is access Tupel;
   type Tupel is record
      Pos1, Pos2 : Z;
      Rest       : TupelPoint:= null;
   end record;


-- ErzeugeAdiMatrix erzeugt eine Adjazenzmatrix.
   function ErzeugeAdiMatrix (Zeiger:TupelPoint) return Z_Matrix;

-- ErzeugeMenge erzeugt aus einer Adjazenzmatix eine Menge aus 
--  Tupeln.
   function ErzeugeMenge (Matrix:Z_Matrix) return TupelPoint;

-- Druckematrix gibt die bergebene Matrix auf dem Bildschirm aus.
   procedure Druckematrix (M1: Z_Matrix; Bezeichner:String);

-- DruckeMenge gibt die Menge der Tupel auf dem Bildschirm aus.
   procedure DruckeMenge (Point:TupelPoint);


end ToAdi;